
from pathlib import Path
from ctypes import CDLL, c_double, c_void_p

from ..lib.logger import logger


lib = None
try:
    lib = CDLL(str(Path(__file__).parents[1] / 'clib' / 'integrate.so'))

    # FFHS integrand
    lib.ffhsSD.restype = c_double
    lib.ffhsSD.argtypes = (c_double, c_void_p)

    # Log-Gaussian integrands
    lib.logGaussianSD_high.restype = c_double
    lib.logGaussianSD_high.argtypes = (c_double, c_void_p)
    lib.logGaussianSD_low.restype = c_double
    lib.logGaussianSD_low.argtypes = (c_double, c_void_p)

    lib.energyDist_SD.restype = c_double
    lib.energyDist_SD.argtypes = (c_double, c_void_p)

    HAS_C_FUNCS = True
    logger.info('Use C functions')
except OSError:
    HAS_C_FUNCS = False
    logger.info('Use python functions')